<?php
abstract class CaffeineBeverage {

	public final function prepareRecipe() {
		$this->boilWater();
		$this->brew();
		$this->pourInCup();

		if( $this->doesCustomerWantCondiments() ) {
			$this->addCondiments();
		}
	}

	abstract protected function brew();

	abstract protected function addCondiments();

	private function boilWater() {
		echo "Boiling water.\n";
	}

	private function pourInCup() {
		echo "Pouring into cup.\n";
	}

	protected function doesCustomerWantCondiments() {
		return true;
	}

}
