<?php
class Coffee extends CaffeineBeverage {
	private $condiments = array();

	protected function brew() {
		echo "Dripping Coffee through filter.\n";
	}

	protected function addCondiments() {
		$condiments = implode( ' and ', $this->condiments );
		echo "Adding $condiments.\n";
	}

	protected function doesCustomerWantCondiments() {
		$answerSugar = $this->askCondimentQuestion( "Would you like sugar? (y/n)\n", 'sugar' );
		$answerMilk = $this->askCondimentQuestion( "Would you like milk? (y/n)\n", 'milk' );

		if( $answerSugar || $answerMilk ) {
			$answer = true;
		} else {
			$answer = false;
		}

		return $answer;
	}

	private function askCondimentQuestion( $question, $condiment ) {
		$answerSugar = readline( $question );
		$answerSugar = $this->convertAnswerToBoolean( $answerSugar );

		if( $answerSugar ) {
			$this->condiments[] = $condiment;
		}

		return $answerSugar;
	}

	private function convertAnswerToBoolean( $answer ) {
		$answer = substr( $answer, 0, 1 );
		$answer = strtolower( $answer );
		$answer = ( $answer === 'y' ) ? true : false;

		return $answer;
	}

}
